// flame.cpp : main source file for flame.exe
//

#include "stdafx.h"

// We only need the WINVER>=0x0500 defs for EnumDisplayMonitors, and
// WTL uses other stuff which might not be in earlier Platform SDKs
//#undef WINVER
//#define WINVER 0x0400

#include <atlframe.h>
#include <atlctrls.h>
#include <atldlgs.h>
#include <atlctrlw.h>

#include <stdio.h>

#include "resource.h"

#include "savewnd.h"
#include "aboutdlg.h"
#include "settingsdlg.h"

#include "hack.h"

CServerAppModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
END_OBJECT_MAP()

int Settings(HWND hwndParent)
{
    CMessageLoop theLoop;
    _Module.AddMessageLoop(&theLoop);

    CSettingsDlg dlg;
    int nRet = 0;

    if (hwndParent) {
        dlg.DoModal(hwndParent);
    } else {

        if(dlg.Create(NULL) == NULL)
        {
            ATLTRACE(_T("Settings dialog creation failed!\n"));
            return 0;
        }

        _Module.Lock();
        dlg.ShowWindow(SW_SHOW);

        nRet = theLoop.Run();

        _Module.RemoveMessageLoop();
    }

    return nRet;
}

int nMonitors = 0;
int cur_mon = 0;
LPRECT rcMon = NULL;
CSaveWnd *pSaveWnds = NULL;

BOOL CALLBACK MyMonProc(HMONITOR hMon, HDC hdc, LPRECT lprc, LPARAM dwData)
{
    ATLTRACE(_T("hMon=%p hdc=%p lprc=(%d,%d,%d,%d) dwData=%p\n"), hMon, hdc, lprc->left, lprc->top, lprc->right, lprc->bottom, dwData);
    switch (dwData) {
    case 0:
        nMonitors++;
        break;
    case 1:
        rcMon[cur_mon++] = *lprc;
        break;
    }
    return TRUE;
}

typedef WINUSERAPI BOOL (WINAPI* LPFNENUMMONS)(HDC,LPCRECT,MONITORENUMPROC,LPARAM);

int SaveScreen()
{
    CMessageLoop theLoop;
    _Module.AddMessageLoop(&theLoop);

    load_prefs();

    LPFNENUMMONS pEnumMons = NULL;
    HMODULE hUser32 = GetModuleHandle(_T("USER32"));
    if (hUser32) {
        pEnumMons = (LPFNENUMMONS)GetProcAddress(hUser32, _T("EnumDisplayMonitors"));
    }

    if (pEnumMons) {
        pEnumMons(NULL, NULL, MyMonProc, 0);
    }

    if (nMonitors>1) {
        rcMon = new RECT[nMonitors];
        EnumDisplayMonitors(NULL, NULL, MyMonProc, 1);

        pSaveWnds = new CSaveWnd[nMonitors];

        for ( int i=0 ; i<nMonitors ; i++ ) {
            if (pSaveWnds[i].Create(NULL, true, true, rcMon+i, pSaveWnds, nMonitors)==NULL) {
                ATLTRACE(_T("Saver window creation failed!\n"));
                delete[] pSaveWnds;
                delete[] rcMon;
                return 0;
            }
        }

        _Module.Lock();
        for ( i=0 ; i<nMonitors ; i++ ) {
            pSaveWnds[i].ShowWindow(SW_SHOW);
        }
    } else {
        pSaveWnds = new CSaveWnd;

        if(pSaveWnds->Create(NULL, true, true) == NULL)
        {
            ATLTRACE(_T("Saver window creation failed!\n"));
            return 0;
        }

        _Module.Lock();
        pSaveWnds->ShowWindow(SW_SHOW);
    }


    int nRet = theLoop.Run();

    if (nMonitors>1) {
        for ( int i=0 ; i<nMonitors ; i++ ) {
            if (pSaveWnds[i].m_hWnd) pSaveWnds[i].DestroyWindow();
        }
        delete[] pSaveWnds;
        delete[] rcMon;
    } else {
        delete pSaveWnds;
    }

    _Module.RemoveMessageLoop();
    return nRet;
}

int Preview(HWND hwndParent)
{
    CMessageLoop theLoop;
    _Module.AddMessageLoop(&theLoop);

    CSaveWnd wnd;

    if(wnd.Create(hwndParent, false, true) == NULL)
    {
        ATLTRACE(_T("Preview window creation failed!\n"));
        return 0;
    }

    _Module.Lock();
    wnd.ShowWindow(SW_SHOW);

    int nRet = theLoop.Run();

    _Module.RemoveMessageLoop();
    return nRet;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
    HRESULT hRes = S_OK;
// If you are running on NT 4.0 or higher you can use the following call instead to 
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//  HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
    ATLASSERT(SUCCEEDED(hRes));

#if (_WIN32_IE >= 0x0300)
    INITCOMMONCONTROLSEX iccx;
    iccx.dwSize = sizeof(iccx);
    iccx.dwICC = ICC_COOL_CLASSES | ICC_BAR_CLASSES;
    BOOL bRet = ::InitCommonControlsEx(&iccx);
    bRet;
    ATLASSERT(bRet);
#else
    ::InitCommonControls();
#endif

    hRes = _Module.Init(ObjectMap, hInstance);
    ATLASSERT(SUCCEEDED(hRes));


    int nRet = 0;
    TCHAR szTokens[] = _T("-/");
    bool bRun = false;
    bool bPreview = false;
    HWND hwndParent = NULL;

//    __asm { int 3 } ;

    LPCTSTR lpszToken = _Module.FindOneOf(::GetCommandLine(), szTokens);
    while(lpszToken != NULL)
    {
        if(_tcsnicmp(lpszToken, _T("c"), 1) == 0)
        {
            bRun = bPreview = false;
            hwndParent = GetForegroundWindow();
        }
        else if(_tcsnicmp(lpszToken, _T("p "), 2) == 0)
        {
            bPreview = true;
            bRun = false;
            int n = 0;
            _stscanf(lpszToken+1, _T("%i%n"), &hwndParent, &n);
            lpszToken += n+1;
        }
        else if(_tcsnicmp(lpszToken, _T("s"), 1) == 0)
        {
            bPreview = false;
            bRun = true;
        }
        lpszToken = _Module.FindOneOf(lpszToken, szTokens);
    }

    ya_rand_init(GetTickCount());

    if (bPreview) nRet = Preview(hwndParent);
    else if (bRun) nRet = SaveScreen();
    else Settings(hwndParent);

    _Module.Term();

    return nRet;
}
