#ifndef FLAMEHACK_H
#define FLAMEHACK_H

void load_prefs();
void save_prefs();
void reset_prefs();
int get_integer_resource(char *name, char *dummy=NULL);
void put_integer_resource(char *name, int val);

#define M_PI 3.1415926535897932384626433832795
#define M_PI_2 1.5707963267948966192313216916398

#define POINT_BUFFER_SIZE 10
#define MAXLEV 4
#define MAXKINDS  10

typedef struct {
	double f[2][3][MAXLEV];	/* three non-homogeneous transforms */
	int max_total;
	int max_levels;
	int max_points;
	int cur_level;
	int variation;
	int snum;
	int anum;
	int num_points;
	int total_points;
	int pixcol;
	int ncolors;

    bool first;

	LOGPALETTE *colors;
	COLORREF cur_col;
	HPALETTE flamepal;

	POINT points [POINT_BUFFER_SIZE];

	int delay, delay2;
	int width, height;
} flame_struct;

flame_struct* init_flame(HWND hwnd);
bool flame (flame_struct *p, HWND hwnd, HDC hdc);

void ya_rand_init(unsigned int seed);


#endif /* FLAMEHACK_H */