// savewnd.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SAVEWND_H__700E0DD3_557C_427B_9CF7_AB4B2E646168__INCLUDED_)
#define AFX_SAVEWND_H__700E0DD3_557C_427B_9CF7_AB4B2E646168__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "hack.h"

class CSaveWnd : public CWindowImpl<CSaveWnd>
{
public:
    CSaveWnd()
    {
        m_bOn = false;
        m_bHaveCoord = false;
    }


    DECLARE_WND_CLASS("WindowsScreenSaverClass")

    BEGIN_MSG_MAP(CSaveWnd)
        MESSAGE_HANDLER(WM_TIMER, OnTimer)
        MESSAGE_HANDLER(WM_SETCURSOR, OnSetCursor)
        MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBkgnd)
        MESSAGE_HANDLER(WM_PAINT, OnPaint)
        MESSAGE_HANDLER(WM_SHOWWINDOW, OnShowWindow)
        MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
        MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
        MESSAGE_HANDLER(WM_MBUTTONDOWN, OnMButtonDown)
        MESSAGE_HANDLER(WM_RBUTTONDOWN, OnRButtonDown)
        MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove)
        MESSAGE_HANDLER(WM_KEYDOWN, OnKeyDown)
        MESSAGE_HANDLER(WM_ACTIVATE, OnActivate)
    END_MSG_MAP()

    bool m_bTouchExit;
    bool m_bDestroyQuits;

    flame_struct *p;

    CSaveWnd *m_pOthers;
    int m_nOthers;

    HWND  Create(HWND hwndParent, bool bTouchExit, bool bDestroyQuits, LPRECT lprc=NULL, CSaveWnd *pOthers=NULL, int nOthers=0)
    {
        m_bTouchExit = bTouchExit;
        m_bDestroyQuits = bDestroyQuits;
        m_pOthers = pOthers;
        m_nOthers = nOthers;

        RECT rc;

        DWORD dwStyle = WS_CHILD;
        DWORD dwExStyle = 0;

        if (!hwndParent) {
            if (!lprc) {
                hwndParent = GetDesktopWindow();
                dwStyle = WS_POPUP;
                dwExStyle = WS_EX_TOPMOST;
                ::GetWindowRect(hwndParent, &rc);
                ::ScreenToClientRect(hwndParent, &rc);
            } else {
                dwStyle = WS_POPUP;
                dwExStyle = WS_EX_TOPMOST;
                rc = *lprc;
            }
        } else {
            ::GetWindowRect(hwndParent, &rc);
            ::ScreenToClientRect(hwndParent, &rc);
        }

        HWND rv = CWindowImpl<CSaveWnd>::Create(hwndParent, rc, "FlameScreenSaver", dwStyle, dwExStyle);

        if (rv) {
            p = init_flame(rv);
        }

        return rv;
    }

    void EnableUpdates(bool bEnable)
    {
        if (p->first) {
            if (bEnable && !m_bOn) {
                SetTimer(666, p->delay);
            } else if (!bEnable && m_bOn) {
                KillTimer(666);
            }
        }

        m_bOn = bEnable;
    }

    LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
    {
        EnableUpdates(false);

        if (m_bDestroyQuits) {
            ::PostQuitMessage(0);
        }
        return 0;
    }

    bool m_bOn;

    LRESULT OnShowWindow(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        EnableUpdates(!!wParam);

        bHandled = FALSE;
        return 0;
    }

    LRESULT OnEraseBkgnd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        HDC hdc = (HDC)wParam;

        RECT rc;
        GetClientRect(&rc);

//        HBRUSH hbrold = (HBRUSH)SelectObject(hdc, GetStockObject(BLACK_BRUSH));

        FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));

        return 1;
    }

    LRESULT OnPaint(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        PAINTSTRUCT ps;
        BeginPaint(&ps);

#if 0
        RECT rc;
        GetClientRect(&rc);
        rc.left = (rc.left*2+rc.right)/3;
        rc.right = (rc.left+2*rc.right)/3;
        FillRect(ps.hdc, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));
#endif

        EndPaint(&ps);

        return 0;
    }

    bool DoFlame()
    {
        HDC hdc = GetDC();
        bool rv = flame(p, m_hWnd, hdc);
        ReleaseDC(hdc);
        return rv;
    }

    LRESULT OnTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        if (wParam==666) {
            KillTimer(666);
            bool rv = DoFlame();
            if (m_nOthers) {
                for ( int i=0 ; i<m_nOthers ; i++ ) {
                    if (m_pOthers[i].m_hWnd!=m_hWnd) m_pOthers[i].DoFlame();
                }
            }

            DWORD dwMillis = rv ? p->delay2 : p->delay;
            if (dwMillis>0) {
                SetTimer(666, dwMillis);
            } else {
                PostMessage(WM_TIMER, 666, NULL);
            }
        } else {
            bHandled = FALSE;
        }

        return 0;
    }

    LRESULT OnSetCursor(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        if (m_bTouchExit) {
            SetCursor(NULL);
            return TRUE;
        }

        return FALSE;
    }

    bool m_bHaveCoord;
    LPARAM m_coord;

    LRESULT OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        if (m_bTouchExit) {
            if (m_bHaveCoord && m_coord!=lParam) {
                PostMessage(WM_CLOSE, 0, 0);
            } else {
                m_coord = lParam;
                m_bHaveCoord = true;
            }
        }

        bHandled = FALSE;
        return 0;
    }

    LRESULT OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        if (m_bTouchExit) {
            PostMessage(WM_CLOSE, 0, 0);
        }

        bHandled = FALSE;
        return 0;
    }

    LRESULT OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        if (m_bTouchExit) {
            PostMessage(WM_CLOSE, 0, 0);
        }

        bHandled = FALSE;
        return 0;
    }

    LRESULT OnMButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        if (m_bTouchExit) {
            PostMessage(WM_CLOSE, 0, 0);
        }

        bHandled = FALSE;
        return 0;
    }

    LRESULT OnRButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        if (m_bTouchExit) {
            PostMessage(WM_CLOSE, 0, 0);
        }

        bHandled = FALSE;
        return 0;
    }

    LRESULT OnActivate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        if (!wParam && m_bTouchExit) {
            if (m_nOthers) {
                for ( int i=0 ; i<m_nOthers ; i++ ) {
                    if (m_pOthers[i].m_hWnd==(HWND)lParam) {
                        bHandled = FALSE;
                        return 0;
                    }
                }
            }
            PostMessage(WM_CLOSE, 0, 0);
        }

        bHandled = FALSE;
        return 0;
    }
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINDLG_H__700E0DD3_557C_427B_9CF7_AB4B2E646168__INCLUDED_)
