// settingsdlg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SETTINGSDLG_H__700E0DD3_557C_427B_9CF7_AB4B2E646168__INCLUDED_)
#define AFX_SETTINGSDLG_H__700E0DD3_557C_427B_9CF7_AB4B2E646168__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CSettingsDlg : public CDialogImpl<CSettingsDlg>, public CUpdateUI<CSettingsDlg>,
		public CMessageFilter, public CIdleHandler
{
public:
    CSettingsDlg()
    {
        m_bModalDlg = false;
    }

    bool m_bModalDlg;

	enum { IDD = IDD_SETTINGSDLG };

	virtual BOOL PreTranslateMessage(MSG* pMsg)
	{
		return IsDialogMessage(pMsg);
	}

	virtual BOOL OnIdle()
	{
		return FALSE;
	}

    int DoModal(HWND hWndParent = ::GetActiveWindow(), LPARAM dwInitParam = NULL)
    {
        m_bModalDlg = true;
        return CDialogImpl<CSettingsDlg>::DoModal(hWndParent, dwInitParam);
    }

	BEGIN_MSG_MAP(CSettingsDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)

        MESSAGE_HANDLER(WM_HSCROLL, OnHScroll)

		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		COMMAND_ID_HANDLER(ID_DEFAULTS, OnDefaults)
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAbout)
	END_MSG_MAP()

	BEGIN_UPDATE_UI_MAP(CSettingsDlg)
	END_UPDATE_UI_MAP()

    void SetCtlCur(UINT nIDT, UINT nIDV, int sc=1)
    {
        DWORD val = SendDlgItemMessage(nIDT, TBM_GETPOS, 0, 0);
        SetDlgItemInt(nIDV, val*sc);
    }
    
    void LoadPrefs()
    {
        reset_prefs();
        load_prefs();

        SendDlgItemMessage(IDC_SLIDER_COLORS, TBM_SETRANGE, TRUE, MAKELONG(2, 192));
        SendDlgItemMessage(IDC_SLIDER_COLORS, TBM_SETPOS, TRUE, get_integer_resource("colors", "Integer"));
        SendDlgItemMessage(IDC_SLIDER_ITERATIONS, TBM_SETRANGE, TRUE, MAKELONG(1, 200));
        SendDlgItemMessage(IDC_SLIDER_ITERATIONS, TBM_SETPOS, TRUE, get_integer_resource("iterations", "Integer"));
        SendDlgItemMessage(IDC_SLIDER_SMALLDELAY, TBM_SETRANGE, TRUE, MAKELONG(10, 2000));
        SendDlgItemMessage(IDC_SLIDER_SMALLDELAY, TBM_SETPOS, TRUE, get_integer_resource("delay", "Integer"));
        SendDlgItemMessage(IDC_SLIDER_BIGDELAY, TBM_SETRANGE, TRUE, MAKELONG(100, 10000));
        SendDlgItemMessage(IDC_SLIDER_BIGDELAY, TBM_SETPOS, TRUE, get_integer_resource("delay2", "Integer"));
        SendDlgItemMessage(IDC_SLIDER_POINTS, TBM_SETRANGE, TRUE, MAKELONG(200, 5000));
        SendDlgItemMessage(IDC_SLIDER_POINTS, TBM_SETPOS, TRUE, get_integer_resource("points", "Integer")/10);

        SetCtlCur(IDC_SLIDER_COLORS, IDC_CURCOLORS);
        SetCtlCur(IDC_SLIDER_ITERATIONS, IDC_CURITERATIONS);
        SetCtlCur(IDC_SLIDER_SMALLDELAY, IDC_CURSMALLDELAY);
        SetCtlCur(IDC_SLIDER_BIGDELAY, IDC_CURBIGDELAY);
        SetCtlCur(IDC_SLIDER_POINTS, IDC_CURPOINTS, 10);
    }

    void SavePrefs()
    {
        reset_prefs();

        put_integer_resource("colors", SendDlgItemMessage(IDC_SLIDER_COLORS, TBM_GETPOS, 0, 0));
        put_integer_resource("iterations", SendDlgItemMessage(IDC_SLIDER_ITERATIONS, TBM_GETPOS, 0, 0));
        put_integer_resource("delay", SendDlgItemMessage(IDC_SLIDER_SMALLDELAY, TBM_GETPOS, 0, 0));
        put_integer_resource("delay2", SendDlgItemMessage(IDC_SLIDER_BIGDELAY, TBM_GETPOS, 0, 0));
        put_integer_resource("points", 10*SendDlgItemMessage(IDC_SLIDER_POINTS, TBM_GETPOS, 0, 0));

        save_prefs();
    }

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
        // Initialise window

        LoadPrefs();

		// center the dialog on the screen
		CenterWindow();

		// set icons
		HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
		SetIcon(hIcon, TRUE);
		HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
		SetIcon(hIconSmall, FALSE);

		// register object for message filtering and idle updates
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		ATLASSERT(pLoop != NULL);
		pLoop->AddMessageFilter(this);
		pLoop->AddIdleHandler(this);

		UIAddChildWindowContainer(m_hWnd);

		return TRUE;
	}

	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		// unregister message filtering and idle updates
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		ATLASSERT(pLoop != NULL);
		pLoop->RemoveMessageFilter(this);
		pLoop->RemoveIdleHandler(this);
		// if UI is the last thread, no need to wait
		if(_Module.GetLockCount() == 1)
		{
			_Module.m_dwTimeOut = 0L;
			_Module.m_dwPause = 0L;
		}
		_Module.Unlock();
		return 0;
	}

    LRESULT OnHScroll(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        UINT nIDT = ::GetDlgCtrlID((HWND)lParam);
        UINT nIDV = 0;
        int sc = 1;
        switch (nIDT) {
        case IDC_SLIDER_COLORS: nIDV = IDC_CURCOLORS; break;
        case IDC_SLIDER_ITERATIONS: nIDV = IDC_CURITERATIONS; break;
        case IDC_SLIDER_SMALLDELAY: nIDV = IDC_CURSMALLDELAY; break;
        case IDC_SLIDER_BIGDELAY: nIDV = IDC_CURBIGDELAY; break;
        case IDC_SLIDER_POINTS: nIDV = IDC_CURPOINTS; sc = 10; break;
        default: return 0;
        }

        SetCtlCur(nIDT, nIDV, sc);
        return 0;
    }

	LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
        SavePrefs();

		// TODO: Add validation code 
        if (m_bModalDlg) {
            EndDialog(wID);
        } else {
		    CloseDialog(wID);
        }
		return 0;
	}

	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
        if (m_bModalDlg) {
            EndDialog(wID);
        } else {
		    CloseDialog(wID);
        }
		return 0;
	}

	LRESULT OnDefaults(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
        reset_prefs();
        LoadPrefs();
		return 0;
	}

	LRESULT OnAbout(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
        CAboutDlg dlg;
        dlg.DoModal();
		return 0;
	}

	void CloseDialog(int nVal)
	{
		DestroyWindow();
		::PostQuitMessage(nVal);
	}
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETTINGSDLG_H__700E0DD3_557C_427B_9CF7_AB4B2E646168__INCLUDED_)
